function [C] = generate_constraints_by_number_C1(X, y, num_constraints)

% generate_constraints : generate contextual constraints

% [chunks, neglinks, S, D] = generate_constraints(X, y, p1, p2)

%	X  - d*n data features

%	y  - 1*n class labels

%	p1 - percentage of positive constraints to be produced

%	p2 - percentage of positive constraints to be produced

% returns:

%	chunks   - n*1 vector: to mark chunket id of connected data examples

%   neglinks - k*k matrix: to count the negative links between chunklets 

%   S        - n*n pairwise similarity matrix

%   D        - n*n pairwise dissimilarity matrix



% Copyright (c) 2005-2006 Steven CH Hoi

% All rights Reserved





% [M C] = genPWC(labels,nM,nC)
% generate pairwise constraints
% labels - label vector
% nM - number of must-links for each cluster
% nC - number of cannot-links for every two clusters
labels = y;
labels = labels(:);

% label marker
u = unique(labels);

% number of clusters
k = length(u);

M = []; 
C = [];

n = length(labels);
% cons = [ceil(rand(num_constraints,1)*n) ceil(rand(num_constraints,1)*n)];
% Mu = cons(:,1)==cons(:,2);
% Cl = cons(:,1)~=cons(:,2);
% M = cons(Mu,:) ;
% C = cons(Cl,:);
% M = [M ones(size(M,1),1) ones(size(M,1),1)];
% C = [C -ones(size(C,1),1) ones(size(C,1),1)];
% C = [M;C];

nM = num_constraints/2;
nC = num_constraints-nM;
nM =  ceil(nM/k);
nC = ceil(nC/k);
% must-link
for i = 1:k
    idx = find(labels==u(i));
    n = length(idx);
    M = [M;[idx(ceil(rand(nM,1)*n)),idx(ceil(rand(nM,1)*n))]];
end

% cannot-link
for i = 1:k
    for j = i+1:k
        idx1 = find(labels==u(i)); idx2 = find(labels==u(j));
        n1 = length(idx1); n2 = length(idx2);
        C =[C;[idx1(ceil(rand(nC,1)*n1)),idx2(ceil(rand(nC,1)*n2))]];
    end
end

M = [M ones(size(M,1),1) ones(size(M,1),1)];
C = [C -ones(size(C,1),1) ones(size(C,1),1)];
C = [M;C];

